program  Image
        use sep
        implicit none

        integer                                 :: n1,n2,n3,n4,n5,n6,esize,interp
        integer                                 :: j1,i4,start,finish
        real                                    :: d1,d2,d3,d4,d5,d6
        real                                    :: o1,o2,o3,o4,o5,o6
        real                                    :: min,max
        integer                                 :: n1out,jshot,fshot,nshots,tshots
        complex,   dimension(:,:,:), allocatable :: indat,outdat
        integer, external                       :: sreed,sseek_block,srite
        !! hook up SEP init stuff and get input parameters from history file
        call sep_init ()

        call from_history ("n1",n1); call from_history ("d1",d1); call from_history("o1",o1)
        call from_history ("n2",n2); call from_history ("d2",d2); call from_history("o3",o2)
        call from_history ("n3",n3); call from_history ("d3",d3); call from_history("o3",o3)
        call from_history ("n4",n4); call from_history ("d4",d4); call from_history("o5",o4)
        call from_history ("n5",n5); call from_history ("d5",d5); call from_history("o5",o5)
        call from_history ("n6",n6); call from_history ("d6",d6); call from_history("o6",o6)
       !!collapse axes assumes 2D w/ offsets: x,1,h,1,w,z to: x,h,w,z
if(n5 /= 1) then
        n2=n3;d2=d3;o2=o3
        n3=n5;d3=d5;o3=o5
        n4=n6;d4=d6;o4=o6
        call to_history("n5",1);  call to_history("n6",1)
end if
        call to_history("n2",n2); call to_history("n3",n3);call to_history("n4",n4)
        call to_history("d2",d2); call to_history("d3",d3);call to_history("d4",d4)
        call to_history("o2",o2); call to_history("o3",o3);call to_history("o4",o4)

        call from_history ("esize",esize)
        call from_param('jshot',jshot,1)
        call from_param("interp",interp,1)
        jshot=jshot*interp
        call from_param('fshot',fshot,0)
        call from_param('tshots',tshots,100)
        nshots=1. + (tshots-fshot-1)/jshot
        call to_history ("totalshotsinsurvey",tshots)
        call to_history ("numberofshotsimaged",nshots); call to_history ("jshot",jshot)
        call sep_close()

        allocate (indat(n1,n2,n3))
        allocate (outdat(n1+tshots-1,n2,n3));outdat=(0.,0.)
        call sep_read(indat)
        
     do i4=1,n4
        do j1=1,nshots
           start=1+ (j1-1)*jshot
           finish=start+n1-1
           outdat(start:finish,:,:)=outdat(start:finish,:,:) + indat
        end do
        call sep_write(outdat(1:n1,:,:))
     end do
deallocate(indat,outdat)
end program Image
