program  InteriorPad
        use sep
        implicit none

        integer                                 :: n1,n2,n3,n4,n5,esize
        real                                    :: d1,d2,d3,d4,d5
        real                                    :: o1,o2,o3,o4,o5
        integer                                 :: n1out,n2out,n3out,n4out
        real                                    :: d1out,d2out,d3out,d4out
        integer                                 :: jtrace1,jtrace2,jtrace3,jtrace4
        integer                                 :: i1,i2,i3,i4
        real   ,   dimension(:,:,:,:,:), allocatable:: indat4,bigdat4
        complex,   dimension(:,:,:,:,:), allocatable:: indat8,bigdat8

        !! hook up SEP init stuff and get input parameters from history file
        call sep_init ()
        call from_history ("n1",n1); call from_history ("d1",d1); call from_history("o1",o1)
        call from_history ("n2",n2); call from_history ("d2",d2); call from_history("o2",o2)
        call from_history ("n3",n3); call from_history ("d3",d3); call from_history("o3",o3)
        call from_history ("n4",n4); call from_history ("d4",d4); call from_history("o4",o4)
        call from_history ("n5",n5); call from_history ("d5",d5); call from_history("o5",o5)
        call from_history ("esize",esize)
        call from_param('jtrace1',jtrace1,n1)
        call from_param('jtrace2',jtrace2,n2)
        call from_param('jtrace3',jtrace3,n3)
        call from_param('jtrace4',jtrace4,n4)
        if((jtrace1 .gt. 50) .or. (jtrace2.gt.50) .or. (jtrace3.gt.50).or.(jtrace4.gt.50)) &
            call seperr('No fucking way')
        call from_param('n1out',n1out,n1*jtrace1)
        call from_param('n2out',n2out,n2*jtrace2)
        call from_param('n3out',n3out,n3*jtrace3)
        call from_param('n4out',n4out,n4*jtrace4)
write(0,*) 'File growing like:'
write(0,*) 'n1',n1,'-->',n1out
write(0,*) 'n2',n2,'-->',n2out
write(0,*) 'n3',n3,'-->',n3out
write(0,*) 'n4',n4,'-->',n4out
        d1out=d1/jtrace1
        d2out=d2/jtrace2
        d3out=d3/jtrace3
        d4out=d4/jtrace4

        call to_history('n1',n1out);call to_history('d1',d1out)
        call to_history('n2',n2out);call to_history('d2',d2out)
        call to_history('n3',n3out);call to_history('d3',d3out)
        call to_history('n4',n4out);call to_history('d4',d4out)
        call to_history('n5',n5   );call to_history('d5',d5)
        call sep_close()

        if (esize==8)then
           allocate (indat8(n1,n2,n3,n4,n5))
           allocate (bigdat8(n1out,n2out,n3out,n4out,n5));bigdat8=0.
           call sep_read(indat8)
        elseif( esize==4)then
           allocate (indat4(n1,n2,n3,n4,n5))
           allocate (bigdat4(n1out,n2out,n3out,n4out,n5));bigdat4=0.
           call sep_read(indat4)
        end if
        do i4=1,n4
        do i3=1,n3
        do i2=1,n2
        do i1=1,n1
        if (esize==8)then
           bigdat8(jtrace1*(i1-1)+1,jtrace2*(i2-1)+1,jtrace3*(i3-1)+1,jtrace4*(i4-1)+1,:)= &
                     indat8(i1,              i2,              i3,              i4,     :)
        elseif( esize==4)then
           bigdat4(jtrace1*(i1-1)+1,jtrace2*(i2-1)+1,jtrace3*(i3-1)+1,jtrace4*(i4-1)+1,:)= &
                     indat4(i1,              i2,              i3,              i4,     :)
        end if
        end do;end do;end do;end do
        if (esize==8)then
           deallocate (indat8)
           call sep_write(bigdat8(1:n1out,1:n2out,1:n3out,1:n4out,:))
           deallocate (bigdat8)
        elseif(esize==4)then
           deallocate (indat4)
           call sep_write(bigdat4(1:n1out,1:n2out,1:n3out,1:n4out,:))
           deallocate (bigdat4)
        end if

     end program
